package fxHarakka.luokat;
import java.time.LocalDate;
/**
 * ---------------------Tehtava == yhden tehtän luokka-----------------------
 * | Vastuualueet:                                      |                   |
 * |                                                    |                   |
 * | - Ei tiedä muista luokista mitään                  |                   |
 * | - Omien kenttien muokkaus pyydettäessä omista      |                   |
 * |    kentistä                                        |                   |
 * |        -id                                         |                   |
 * |        -nimi                                       |                   |
 * |        -aika                                       |                   |
 * |        -päivä                                      |                   |
 * |        -lisätietoa                                 |                   |
 * |                                                    |                   |
 * | - Osaa hyväksyä vain kentille määritellyn muodon   |                   |
 * |  (syntaksi)                                        |                   |
 * | - Osaa get metodit omille attribuuteille           |                   |
 * | - Osaa muodostaa itsensä merkkijonoksi             |                   |
 * -------------------------------------------------------------------------
 */
public class Tehtava {

    private String nimi;                     //tehtävän nimi
    //private Aika aika;                     // TODO tehään myös aika luokka
    private String paiva = "";               //tehtävän viikonpäivä (voidaan tehtä Vpaiva luokka)
    private int id;                          //tehtävän id numero
    private String lisatieto = "";           //tehtävän lisätiedot



    /**
     *TODO sitten kun Pvm ja Aika luokat lisätty ne pitää lisätä muodostajaan ja ainakin tällä hetkellä
     * lisaa Tehtaa metodiin
     */
    //-----------------------MUODOSTAJAT - TEHTAVA----------------------------
    public Tehtava() {
        this.nimi = "";
        this.paiva = "";
        this.id = 0;      //id 0 varattu tehtäville joille ei asetettu linkkiä projektiin
        this.lisatieto = "";

    }

    public Tehtava(String nimi, int id) {
        this.nimi = nimi;
        this.paiva = "";   //päivää ei määritetty
        this.id = id;      //id 0 varattu tehtäville joille ei asetettu linkkiä projektiin
        this.lisatieto = "";
    }


    public Tehtava(String nimi, String paiva, int id, String lisatieto) {
        this.nimi = nimi;
        this.paiva = paiva;
        this.id = id;      //id 0 varattu tehtäville joille ei asetettu linkkiä projektiin
        this.lisatieto = lisatieto;
    }


    //-----------------------METODIT - TEHTAVA----------------------------

    /**
     * asettaa tehtävälle nimen
     * @param nimi
     */
   public void setNimi(String nimi){
        this.nimi = nimi;

   }

    /**
     *
     * @return tehtävän nimi
     */
   public String getNimi(){
       return this.nimi;
   }

    /**
     * voidaan tehdä jos on aikaa niin Vpaiva luokka joka ottaa vastaan vaan viikonpäiviä
     * formaatilla Ma,Ti,Ke,To,Pe,La,Su
     * mutta tällä hetkellä ottaa vastaan String
     */
    public void setPaiva(String paiva){
        String[] paivat = {"Ma", "Ti", "Ke", "To", "Pe", "La", "Su"};
        for (String i : paivat){
            if (paiva.equalsIgnoreCase(i)) this.paiva = paiva; //ottaa vastaan vaan päivän ja ei välitä asusta
        }
    }

    /**
     * asettaa tehtävälle id numeron
     */
    public void setId(){


    }

    /**
     *
     * @return tehtävän lisätiedot String muodossa
     */
    public String getLisatieto(){

        return this.lisatieto;
    }

    /**
     * lisää tehtävälle lisätietoaja
     *
     * @param lisatieto String: lisättävät lisätiedot
     * @param append jos true niin append modessa eli lisätään vanhan tekstin perään
     *               jos false niin korvataan vanha.
     * @example <pre name="test">
     * #import fxHarakka.luokat.Tehtava;
     * Tehtava teht1 = new Tehtava();
     * teht1.setLisatieto("testi", false);
     * teht1.getLisatieto() === "testi";
     * teht1.setLisatieto("testi2", false);
     * teht1.getLisatieto() === "testi2";
     * teht1.setLisatieto("testi3", true);
     * teht1.getLisatieto() === "testi2testi3";
     * </pre>
     */
    public void setLisatieto(String lisatieto, boolean append){
        //append moodi päällä lisää vanhan perään
        if (append) {
            String lisattava = "";
            lisattava = this.getLisatieto() + lisatieto;
            this.lisatieto = lisattava;
        }else {
            //ilman append moodia korvaa vanhan uudella lisätiedolla
            this.lisatieto = lisatieto;
        }

    }

    





}
